#include <File_Receiver.h>
using namespace inaf::oasbo::Receivers;

FileReceiverBuilder::FileReceiverBuilder() {
	this->reset();
}

FileReceiverBuilder::~FileReceiverBuilder() {
	delete rcv;
}

void FileReceiverBuilder::reset() {
	this->rcv = new FileReceiver();
}

FileReceiverBuilder* FileReceiverBuilder::configFrom(
		Configurators::BaseConfigurator &conf) {
	conf.readConfigFromSource(config_target);
	std::map<std::string, std::string> params = conf.getConfig();

	std::string key = config_target + "_" + source_key;
	if (params.count(key) > 0)
		rcv->setHost(params[key]);

	key = config_target + "_" + rate_key;
	if (params.count(key) > 0) {
		rcv->rate = std::stoi(params[key]);
	}
	return this;
}

FileReceiverBuilder* FileReceiverBuilder::setSource(std::string source) {
	rcv->setHost(source);
	return this;
}

FileReceiverBuilder* FileReceiverBuilder::setRate(int rate) {
	rcv->rate = rate;
	return this;
}

FileReceiver* FileReceiverBuilder::getReceiver() {
	FileReceiver *result = this->rcv;
	this->reset();
	return result;
}
